package cokr.xit.fims.mngt.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.mngt.Ntc;
import cokr.xit.fims.mngt.NtcQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/**공지사항 DAO
 * @author leebj
 */
@Mapper("ntcMapper")
public interface NtcMapper extends AbstractMapper {

	/**지정한 조건에 따라 공지사항 목록을 조회하여 반환한다.<br />
	 * @param req 공지사항 조회 조건
	 * @return 공지사항 목록
	 */
	List<DataObject> selectNtcList(NtcQuery req);

	/**지정한 공지사항ID로 공지사항 객체를 반환한다.
	 * @param ntcId 공지사항 ID
	 * @return 공지사항 객체
	 */
	DataObject selectNtcInfo(String ntcId);

	/**공지사항 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"ntc" - 공지사항</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertNtc(Map<String, Object> params);

	/**공지사항 정보를 등록한다.
	 * @param ntc 공지사항
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(Ntc ntc) {
		return ntc != null && insertNtc(params().set("ntc", ntc)) == 1;
	}

	/**공지사항 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"ntc" - 공지사항</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateNtc(Map<String, Object> params);

	/**공지사항 정보를 수정한다.
	 * @param ntc 공지사항
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(Ntc ntc) {
		return ntc != null && updateNtc(params().set("ntc", ntc)) == 1;
	}

	/**지정한 공지사항을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"ntc" - 공지사항</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteNtc(Map<String, ?> params);

	/**공지사항 정보를 삭제한다.
	 * @param ntc 공지사항
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(Ntc ntc) {
		return ntc != null && deleteNtc(params().set("ntc", ntc)) == 1;
	}

}
